Subject: P1394> Re: SBP-2 Bidirectional ORB

From: "Eric W. Anderson" <[email-masked]>
Date: 6 Oct 97 18:02:38 -0700

I saw this posted to several lists, so I will attempt to collect
all of the replies here.

My own comments are twofold:

1. I agree with David's observation that two ORBs (one read, one
   write) can be used instead of a bidirectional ORB.  A device
   is free to fetch both ORBs and execute them in whatever order
   it likes, including simultaneously.  A device or device class
   can mandate that such ORB pairs be provided, even though SBP-2
   does not require it.

2. I agree with John that the bidirectional ORB will be difficult
   to deal with in software.  Even though the SBP-2 layer is thin,
   there are complex virtual memory issues, and having a special
   ORB with two payloads will complicate that.

I am not *opposed* to bidirectional ORBs, I just think they are not
the best solution.  I think SBP-2 can be used as-is to solve the
problem at hand.  I think that using two ORBs is simpler and leads
to less complicated consequences.  However, I'd be interested to
hear from Peter why the single bidirectional ORB might be preferable.
If there's an advantage I've overlooked, I'd certainly reconsider.

--------------------------------------
Eric Anderson            [email-masked]
Apple Computer, Inc.     (408)974-8187
--------------------------------------

>In a message dated 97-10-06 17:55:15 EDT, [email-masked] writes:
>
><<I think that there are way too many differences between this and the
>unidirectional ORB.  They will make it impossible to write one SBP-2
driver
>that can handle both unidirectional and bi-directional devices.>>
>
>From what I understand in conversation with you, John, is that SBP-2 is
>*so* lightweight that no stand-alone SBP-2 driver is anticipated in your
>operating systems---only very thin SBP-2 layers at the bottom edges of
>device class drivers.
>
>The format I proposed is not the last word but a starting point. There was
>some reason to the choices, for example, a larger data_length field to
>handle unpaged transfers greater than 64 Kb. If you've got improvements
>to suggest I'm open to them.
>
>Peter Johansson

>David Wooten Writes:
>The idea is that the target knows that these things can come in pairs 
>and doesn't reorder dependent things.
>
>David
>
>-----Original Message-----
>From:	[email-masked] [SMTP:[email-masked]]
>Sent:	Monday, October 06, 1997 4:16 PM
>To:	Multiple recipients of list 1394-architecture
>Subject:	Re: SBP-2 Bidirectional ORB
>
>In a message dated 97-10-06 14:53:37 EDT, [email-masked] 
>writes: